Index: cards/FCC/FCChh.tcl
===================================================================
--- cards/FCC/FCChh.tcl	(revision c6667c0b9a201c743a992c626db39c2c6d00d855)
+++ cards/FCC/FCChh.tcl	(revision 93b4a8cb2f4a3f0f36868af68cc3968bdefc6609)
@@ -32,5 +32,6 @@
   Calorimeter
   EFlowMerger
-
+  EFlowFilter
+  
   PhotonEfficiency
   PhotonIsolation
@@ -410,4 +411,18 @@
 }
 
+######################
+# EFlowFilter
+######################
+
+module PdgCodeFilter EFlowFilter {
+  set InputArray EFlowMerger/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
 
 ###################
@@ -573,5 +588,5 @@
 module Isolation PhotonIsolation {
   set CandidateInputArray PhotonEfficiency/photons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray photons
@@ -593,5 +608,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronFilter/electrons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray electrons
@@ -613,5 +628,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonMomentumSmearing/muons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray muons
Index: cards/delphes_card_ATLAS.tcl
===================================================================
--- cards/delphes_card_ATLAS.tcl	(revision c6667c0b9a201c743a992c626db39c2c6d00d855)
+++ cards/delphes_card_ATLAS.tcl	(revision 93b4a8cb2f4a3f0f36868af68cc3968bdefc6609)
@@ -21,5 +21,6 @@
   Calorimeter
   EFlowMerger
-
+  EFlowFilter
+  
   PhotonEfficiency
   PhotonIsolation
@@ -405,4 +406,18 @@
 }
 
+######################
+# EFlowFilter
+######################
+
+module PdgCodeFilter EFlowFilter {
+  set InputArray EFlowMerger/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
 ###################
 # Photon efficiency
@@ -428,5 +443,5 @@
 module Isolation PhotonIsolation {
   set CandidateInputArray PhotonEfficiency/photons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray photons
@@ -439,15 +454,4 @@
 }
 
-#################
-# Electron filter
-#################
-
-module PdgCodeFilter ElectronFilter {
-  set InputArray HCal/eflowTracks
-  set OutputArray electrons
-  set Invert true
-  add PdgCode {11}
-  add PdgCode {-11}
-}
 
 #####################
@@ -474,5 +478,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronEfficiency/electrons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray electrons
@@ -508,5 +512,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonEfficiency/muons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray muons
Index: cards/delphes_card_ATLAS_PileUp.tcl
===================================================================
--- cards/delphes_card_ATLAS_PileUp.tcl	(revision c6667c0b9a201c743a992c626db39c2c6d00d855)
+++ cards/delphes_card_ATLAS_PileUp.tcl	(revision 93b4a8cb2f4a3f0f36868af68cc3968bdefc6609)
@@ -23,5 +23,6 @@
   EFlowMergerAllTracks
   EFlowMerger
-
+  EFlowFilter
+  
   NeutrinoFilter
   GenJetFinder
@@ -372,4 +373,19 @@
 }
 
+######################
+# EFlowFilter
+######################
+
+module PdgCodeFilter EFlowFilter {
+  set InputArray EFlowMergerAllTracks/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+
 #############
 # Rho pile-up
@@ -508,5 +524,5 @@
 module Isolation PhotonIsolation {
   set CandidateInputArray PhotonEfficiency/photons
-  set IsolationInputArray EFlowMergerAllTracks/eflow
+  set IsolationInputArray EFlowFilter/eflow
   set RhoInputArray Rho/rho
 
@@ -543,5 +559,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronEfficiency/electrons
-  set IsolationInputArray EFlowMergerAllTracks/eflow
+  set IsolationInputArray EFlowFilter/eflow
   set RhoInputArray Rho/rho
 
@@ -578,5 +594,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonEfficiency/muons
-  set IsolationInputArray EFlowMergerAllTracks/eflow
+  set IsolationInputArray EFlowFilter/eflow
   set RhoInputArray Rho/rho
 
Index: cards/delphes_card_CMS.tcl
===================================================================
--- cards/delphes_card_CMS.tcl	(revision c6667c0b9a201c743a992c626db39c2c6d00d855)
+++ cards/delphes_card_CMS.tcl	(revision 93b4a8cb2f4a3f0f36868af68cc3968bdefc6609)
@@ -21,5 +21,6 @@
   Calorimeter
   EFlowMerger
-
+  EFlowFilter
+  
   PhotonEfficiency
   PhotonIsolation
@@ -418,4 +419,19 @@
 }
 
+######################
+# EFlowFilter
+######################
+
+module PdgCodeFilter EFlowFilter {
+  set InputArray EFlowMerger/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
+
 ###################
 # Photon efficiency
@@ -441,5 +457,5 @@
 module Isolation PhotonIsolation {
   set CandidateInputArray PhotonEfficiency/photons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray photons
@@ -476,5 +492,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronEfficiency/electrons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray electrons
@@ -510,5 +526,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonEfficiency/muons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray muons
Index: cards/delphes_card_CMS_PileUp.tcl
===================================================================
--- cards/delphes_card_CMS_PileUp.tcl	(revision c6667c0b9a201c743a992c626db39c2c6d00d855)
+++ cards/delphes_card_CMS_PileUp.tcl	(revision 93b4a8cb2f4a3f0f36868af68cc3968bdefc6609)
@@ -26,5 +26,6 @@
   EFlowMergerAllTracks
   EFlowMerger
-
+  EFlowFilter
+  
   NeutrinoFilter
   GenJetFinder
@@ -436,4 +437,17 @@
 }
 
+######################
+# EFlowFilter
+######################
+
+module PdgCodeFilter EFlowFilter {
+  set InputArray EFlowMergerAllTracks/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
 
 ##########################
@@ -653,5 +667,5 @@
 module Isolation PhotonIsolation {
   set CandidateInputArray PhotonEfficiency/photons
-  set IsolationInputArray EFlowMergerAllTracks/eflow
+  set IsolationInputArray EFlowFilter/eflow
   set RhoInputArray Rho/rho
 
@@ -688,5 +702,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronEfficiency/electrons
-  set IsolationInputArray EFlowMergerAllTracks/eflow
+  set IsolationInputArray EFlowFilter/eflow
   set RhoInputArray Rho/rho
 
@@ -724,5 +738,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonEfficiency/muons
-  set IsolationInputArray EFlowMergerAllTracks/eflow
+  set IsolationInputArray EFlowFilter/eflow
   set RhoInputArray Rho/rho
 
Index: cards/delphes_card_ILD.tcl
===================================================================
--- cards/delphes_card_ILD.tcl	(revision c6667c0b9a201c743a992c626db39c2c6d00d855)
+++ cards/delphes_card_ILD.tcl	(revision 93b4a8cb2f4a3f0f36868af68cc3968bdefc6609)
@@ -23,5 +23,6 @@
   Calorimeter
   EFlowMerger
-
+  EFlowFilter
+  
   PhotonEfficiency
   PhotonIsolation
@@ -350,4 +351,18 @@
 }
 
+######################
+# EFlowFilter
+######################
+
+module PdgCodeFilter EFlowFilter {
+  set InputArray EFlowMerger/eflow
+  set OutputArray eflow
+  
+  add PdgCode {11}
+  add PdgCode {-11}
+  add PdgCode {13}
+  add PdgCode {-13}
+}
+
 
 ###################
@@ -491,5 +506,5 @@
 module Isolation PhotonIsolation {
   set CandidateInputArray PhotonEfficiency/photons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray photons
@@ -525,5 +540,5 @@
 module Isolation ElectronIsolation {
   set CandidateInputArray ElectronEfficiency/electrons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray electrons
@@ -561,5 +576,5 @@
 module Isolation MuonIsolation {
   set CandidateInputArray MuonEfficiency/muons
-  set IsolationInputArray EFlowMerger/eflow
+  set IsolationInputArray EFlowFilter/eflow
 
   set OutputArray muons
